=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2009-03-25 21:06:47 +0000
+++ drizzled/definitions.h	2009-04-25 00:00:44 +0000
@@ -109,15 +109,15 @@
 #define MYF_RW MYF(MY_WME+MY_NABP)		/* Vid my_read & my_write */
 
 	/* Extern defines */
-#define store_record(A,B) memcpy((A)->B,(A)->record[0],(size_t) (A)->s->reclength)
-#define restore_record(A,B) memcpy((A)->record[0],(A)->B,(size_t) (A)->s->reclength)
-#define cmp_record(A,B) memcmp((A)->record[0],(A)->B,(size_t) (A)->s->reclength)
-#define empty_record(A)                                 \
+/* #define store_record(A,B) memcpy((A)->B,(A)->record[0],(size_t) (A)->s->reclength) */
+/* #define restore_record(A,B) memcpy((A)->record[0],(A)->B,(size_t) (A)->s->reclength) */
+/* #define cmp_record(A,B) memcmp((A)->record[0],(A)->B,(size_t) (A)->s->reclength) */
+/* #define empty_record(A)                                 \
   do {                                                  \
     restore_record((A),s->default_values);              \
     memset((A)->null_flags, 255, (A)->s->null_bytes);   \
   } while (0)
-
+*/
 	/* Defines for use with openfrm, openprt and openfrd */
 
 #define READ_ALL		1	/* openfrm: Read all parameters */

=== modified file 'drizzled/records.cc'
--- drizzled/records.cc	2009-02-02 18:19:36 +0000
+++ drizzled/records.cc	2009-04-25 00:00:44 +0000
@@ -57,7 +57,7 @@
 void init_read_record_idx(READ_RECORD *info, Session *, Table *table,
                           bool print_error, uint32_t idx)
 {
-  empty_record(table);
+  table->emptyRecord();
   memset(info, 0, sizeof(*info));
   info->table= table;
   info->file=  table->file;
@@ -163,7 +163,7 @@
   }
   else
   {
-    empty_record(table);
+    table->emptyRecord();
     info->record= table->record[0];
     info->ref_length= table->file->ref_length;
   }

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-04-12 20:55:58 +0000
+++ drizzled/show.cc	2009-04-25 00:00:44 +0000
@@ -158,7 +158,7 @@
     struct drizzled_plugin_manifest *plug= plugin_decl(plugin);
     const CHARSET_INFO * const cs= system_charset_info;
   
-    restore_record(table, s->default_values);
+    table->restoreRecordAsDefault();
   
     table->field[0]->store(plugin_name(plugin)->str,
                            plugin_name(plugin)->length, cs);
@@ -468,7 +468,7 @@
       field_list.push_back(new Item_field(field));
     }
   }
-  restore_record(table, s->default_values);              // Get empty record
+  table->restoreRecordAsDefault();              // Get empty record
   table->use_all_columns();
   if (session->protocol->sendFields(&field_list, Protocol::SEND_DEFAULTS))
     return;
@@ -620,7 +620,7 @@
   bool show_table_options= false;
   bitset<MAX_FIELDS> *old_bitmap;
 
-  restore_record(table, s->default_values); // Get empty record
+  table->restoreRecordAsDefault(); // Get empty record
 
   if (share->tmp_table)
     packet->append(STRING_WITH_LEN("CREATE TEMPORARY TABLE "));
@@ -1167,7 +1167,7 @@
       if (! tmp->protocol->isConnected())
         continue;
 
-      restore_record(table, s->default_values);
+      table->restoreRecordAsDefault();
       /* ID */
       table->field[0]->store((int64_t) tmp->thread_id, true);
       /* USER */
@@ -1551,7 +1551,7 @@
           assert(0);
           break;
         }
-        restore_record(table, s->default_values);
+        table->restoreRecordAsDefault();
         table->field[0]->store(name_buffer, strlen(name_buffer),
                                system_charset_info);
         table->field[1]->store(pos, (uint32_t) (end - pos), system_charset_info);
@@ -2521,7 +2521,7 @@
       List_iterator_fast<LEX_STRING> it_files(table_names);
       while ((table_name= it_files++))
       {
-        restore_record(table, s->default_values);
+        table->restoreRecordAsDefault();
         table->field[schema_table->idx_field1]->
           store(db_name->str, db_name->length, system_charset_info);
         table->field[schema_table->idx_field2]->
@@ -2647,7 +2647,7 @@
 bool store_schema_shemata(Session* session, Table *table, LEX_STRING *db_name,
                           const CHARSET_INFO * const cs)
 {
-  restore_record(table, s->default_values);
+  table->restoreRecordAsDefault();
   table->field[1]->store(db_name->str, db_name->length, system_charset_info);
   table->field[2]->store(cs->csname, strlen(cs->csname), system_charset_info);
   table->field[3]->store(cs->name, strlen(cs->name), system_charset_info);
@@ -2725,7 +2725,7 @@
   DRIZZLE_TIME time;
   const CHARSET_INFO * const cs= system_charset_info;
 
-  restore_record(table, s->default_values);
+  table->restoreRecordAsDefault();
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(table_name->str, table_name->length, cs);
   if (res)
@@ -3069,7 +3069,7 @@
 
     count++;
     /* Get default row, with all NULL fields set to NULL */
-    restore_record(table, s->default_values);
+    table->restoreRecordAsDefault();
 
     table->field[1]->store(db_name->str, db_name->length, cs);
     table->field[2]->store(table_name->str, table_name->length, cs);
@@ -3140,7 +3140,7 @@
           wild_case_compare(scs, tmp_cs->csname,wild)))
     {
       const char *comment;
-      restore_record(table, s->default_values);
+      table->restoreRecordAsDefault();
       table->field[0]->store(tmp_cs->csname, strlen(tmp_cs->csname), scs);
       table->field[1]->store(tmp_cs->name, strlen(tmp_cs->name), scs);
       comment= tmp_cs->comment ? tmp_cs->comment : "";
@@ -3178,7 +3178,7 @@
           wild_case_compare(scs, tmp_cl->name,wild)))
       {
         const char *tmp_buff;
-        restore_record(table, s->default_values);
+        table->restoreRecordAsDefault();
         table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
         table->field[1]->store(tmp_cl->csname , strlen(tmp_cl->csname), scs);
         table->field[2]->store((int64_t) tmp_cl->number, true);
@@ -3214,7 +3214,7 @@
       if (!tmp_cl || !(tmp_cl->state & MY_CS_AVAILABLE) ||
           !my_charset_same(tmp_cs,tmp_cl))
 	continue;
-      restore_record(table, s->default_values);
+      table->restoreRecordAsDefault();
       table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
       table->field[1]->store(tmp_cl->csname , strlen(tmp_cl->csname), scs);
       if (schema_table_store_record(session, table))
@@ -3261,7 +3261,7 @@
       const char *str;
       for (uint32_t j=0 ; j < key_info->key_parts ; j++,key_part++)
       {
-        restore_record(table, s->default_values);
+        table->restoreRecordAsDefault();
         table->field[1]->store(db_name->str, db_name->length, cs);
         table->field[2]->store(table_name->str, table_name->length, cs);
         table->field[3]->store((int64_t) ((key_info->flags &
@@ -3327,7 +3327,7 @@
                        uint32_t key_len, const char *con_type, uint32_t con_len)
 {
   const CHARSET_INFO * const cs= system_charset_info;
-  restore_record(table, s->default_values);
+  table->restoreRecordAsDefault();
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(key_name, key_len, cs);
   table->field[3]->store(db_name->str, db_name->length, cs);
@@ -3445,7 +3445,7 @@
         if (key_part->field)
         {
           f_idx++;
-          restore_record(table, s->default_values);
+          table->restoreRecordAsDefault();
           store_key_column_usage(table, db_name, table_name,
                                  key_info->name,
                                  strlen(key_info->name),
@@ -3472,7 +3472,7 @@
       {
         r_info= it1++;
         f_idx++;
-        restore_record(table, s->default_values);
+        table->restoreRecordAsDefault();
         store_key_column_usage(table, db_name, table_name,
                                f_key_info->forein_id->str,
                                f_key_info->forein_id->length,
@@ -3512,7 +3512,7 @@
 
   for (; open_list ; open_list=open_list->next)
   {
-    restore_record(table, s->default_values);
+    table->restoreRecordAsDefault();
     table->field[0]->store(open_list->db, strlen(open_list->db), cs);
     table->field[1]->store(open_list->table, strlen(open_list->table), cs);
     table->field[2]->store((int64_t) open_list->in_use, true);
@@ -3635,7 +3635,7 @@
     List_iterator_fast<FOREIGN_KEY_INFO> it(f_key_list);
     while ((f_key_info= it++))
     {
-      restore_record(table, s->default_values);
+      table->restoreRecordAsDefault();
       table->field[1]->store(db_name->str, db_name->length, cs);
       table->field[9]->store(table_name->str, table_name->length, cs);
       table->field[2]->store(f_key_info->forein_id->str,

=== modified file 'drizzled/sj_tmp_table.cc'
--- drizzled/sj_tmp_table.cc	2009-04-12 19:14:12 +0000
+++ drizzled/sj_tmp_table.cc	2009-04-25 00:00:44 +0000
@@ -262,7 +262,7 @@
   }
 
   //param->recinfo=recinfo;
-  //store_record(table,s->default_values);        // Make empty default record
+  //table->storeRecordAsDefault();        // Make empty default record
 
   if (session->variables.tmp_table_size == ~ (uint64_t) 0)    // No limit
     share->max_rows= ~(ha_rows) 0;

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2009-04-12 19:59:09 +0000
+++ drizzled/sql_insert.cc	2009-04-25 00:00:44 +0000
@@ -350,7 +350,7 @@
   {
     if (fields.elements || !value_count)
     {
-      restore_record(table,s->default_values);	// Get empty record
+      table->restoreRecordAsDefault();	// Get empty record
       if (fill_record(session, fields, *values, 0))
       {
 	if (values_list.elements != 1 && ! session->is_error())
@@ -370,7 +370,7 @@
     else
     {
       if (session->used_tables)			// Column used in values()
-	restore_record(table,s->default_values);	// Get empty record
+	table->restoreRecordAsDefault();	// Get empty record
       else
       {
         /*
@@ -813,8 +813,8 @@
           an error is returned
         */
 	assert(table->insert_values != NULL);
-        store_record(table,insert_values);
-        restore_record(table,record[1]);
+        table->storeRecordAsInsert();
+        table->restoreRecord();
         assert(info->update_fields->elements ==
                     info->update_values->elements);
         if (fill_record(session, *info->update_fields,
@@ -1184,7 +1184,7 @@
     */
     table->file->ha_start_bulk_insert((ha_rows) 0);
   }
-  restore_record(table,s->default_values);		// Get empty record
+  table->restoreRecordAsDefault();		// Get empty record
   table->next_number_field=table->found_next_number_field;
 
   session->cuted_fields=0;
@@ -1279,7 +1279,7 @@
         originally touched by INSERT ... SELECT, so we have to restore
         their original values for the next row.
       */
-      restore_record(table, s->default_values);
+      table->restoreRecordAsDefault();
     }
     if (table->next_number_field)
     {
@@ -1673,7 +1673,7 @@
   table->timestamp_field_type= TIMESTAMP_NO_AUTO_SET;
   table->next_number_field=table->found_next_number_field;
 
-  restore_record(table,s->default_values);      // Get empty record
+  table->restoreRecordAsDefault();      // Get empty record
   session->cuted_fields=0;
   if (info.ignore || info.handle_duplicates != DUP_ERROR)
     table->file->extra(HA_EXTRA_IGNORE_DUP_KEY);

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2009-04-08 23:01:10 +0000
+++ drizzled/sql_load.cc	2009-04-25 00:00:44 +0000
@@ -433,7 +433,7 @@
     read_info.row_end[0]=0;
 #endif
 
-    restore_record(table, s->default_values);
+    table->restoreRecordAsDefault();
     /*
       There is no variables in fields_vars list in this format so
       this conversion is safe.
@@ -536,7 +536,7 @@
       return(1);
     }
 
-    restore_record(table, s->default_values);
+    table->restoreRecordAsDefault();
 
     while ((item= it++))
     {

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-04-12 18:37:16 +0000
+++ drizzled/sql_select.cc	2009-04-25 00:00:44 +0000
@@ -10589,7 +10589,7 @@
   if (table)
   {
     table->file->extra(HA_EXTRA_WRITE_CACHE);
-    empty_record(table);
+    table->emptyRecord();
     if (table->group && join->tmp_table_param.sum_func_count &&
         table->s->keys && !table->file->inited)
       table->file->ha_index_init(0, 0);
@@ -11154,7 +11154,7 @@
     join_tab->found= 1;
     join_tab->not_null_compl= 0;
     /* The outer row is complemented by nulls for each inner tables */
-    restore_record(join_tab->table,s->default_values);  // Make empty record
+    join_tab->table->restoreRecordAsDefault();  // Make empty record
     join_tab->table->mark_as_null_row();       // For group by without error
     select_cond= join_tab->select_cond;
     /* Check all attached conditions for inner table rows. */
@@ -11382,14 +11382,14 @@
       if (error != HA_ERR_END_OF_FILE)
 	return table->report_error(error);
       tab->table->mark_as_null_row();
-      empty_record(table);			// Make empty record
+      table->emptyRecord();			// Make empty record
       return -1;
     }
     update_virtual_fields_marked_for_write(table);
-    store_record(table,record[1]);
+    table->storeRecord();
   }
   else if (!table->status)			// Only happens with left join
-    restore_record(table,record[1]);			// restore old record
+    table->restoreRecord();			// restore old record
   table->null_row=0;
   return table->status ? -1 : 0;
 }
@@ -11429,18 +11429,18 @@
     {
       table->status= STATUS_NOT_FOUND;
       tab->table->mark_as_null_row();
-      empty_record(table);
+      table->emptyRecord();
       if (error != HA_ERR_KEY_NOT_FOUND && error != HA_ERR_END_OF_FILE)
 	return table->report_error(error);
       return -1;
     }
     update_virtual_fields_marked_for_write(table);
-    store_record(table,record[1]);
+    table->storeRecord();
   }
   else if (!(table->status & ~STATUS_NULL_ROW))	// Only happens with left join
   {
     table->status=0;
-    restore_record(table,record[1]);			// restore old record
+    table->restoreRecord();			// restore old record
   }
   table->null_row=0;
   return table->status ? -1 : 0;
@@ -12115,7 +12115,7 @@
                                    HA_WHOLE_KEY,
                                    HA_READ_KEY_EXACT))
   {						/* Update old record */
-    restore_record(table,record[1]);
+    table->restoreRecord();
     update_tmptable_sum_func(join->sum_funcs,table);
     if ((error=table->file->ha_update_row(table->record[1],
                                           table->record[0])))
@@ -12192,7 +12192,7 @@
       table->file->print_error(error,MYF(0));	/* purecov: inspected */
       return(NESTED_LOOP_ERROR);            /* purecov: inspected */
     }
-    restore_record(table,record[1]);
+    table->restoreRecord();
     update_tmptable_sum_func(join->sum_funcs,table);
     if ((error=table->file->ha_update_row(table->record[1],
                                           table->record[0])))

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-04-12 07:28:35 +0000
+++ drizzled/sql_table.cc	2009-04-25 00:00:44 +0000
@@ -3967,7 +3967,7 @@
   if (!(used_fields & HA_CREATE_USED_KEY_BLOCK_SIZE))
     create_info->key_block_size= table->s->key_block_size;
 
-  restore_record(table, s->default_values);     // Empty record for DEFAULT
+  table->restoreRecordAsDefault();     // Empty record for DEFAULT
   Create_field *def;
 
     /*
@@ -5168,7 +5168,7 @@
   if (ignore)
     to->file->extra(HA_EXTRA_IGNORE_DUP_KEY);
   session->row_count= 0;
-  restore_record(to, s->default_values);        // Create empty record
+  to->restoreRecordAsDefault();        // Create empty record
   while (!(error=info.read_record(&info)))
   {
     if (session->killed)

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2009-04-12 19:33:44 +0000
+++ drizzled/sql_update.cc	2009-04-25 00:00:44 +0000
@@ -492,7 +492,7 @@
       if (table->file->was_semi_consistent_read())
         continue;  /* repeat the read of the same row if it still exists */
 
-      store_record(table,record[1]);
+      table->storeRecord();
       if (fill_record(session, fields, values, 0))
         break; /* purecov: inspected */
 
@@ -1324,7 +1324,7 @@
                              HA_PARTIAL_COLUMN_READ) ||
                            ((*table->read_set & *table->write_set) == *table->write_set));
       table->status|= STATUS_UPDATED;
-      store_record(table,record[1]);
+      table->storeRecord();
       if (fill_record(session, *fields_for_table[offset],
                       *values_for_table[offset], 0))
 	return(1);
@@ -1553,7 +1553,7 @@
       } while((tbl= check_opt_it++));
 
       table->status|= STATUS_UPDATED;
-      store_record(table,record[1]);
+      table->storeRecord();
 
       /* Copy data from temporary table to current table */
       for (copy_field_ptr=copy_field;

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-04-13 19:54:54 +0000
+++ drizzled/table.cc	2009-04-25 00:00:44 +0000
@@ -4213,7 +4213,7 @@
 
   param->copy_field_end=copy;
   param->recinfo=recinfo;
-  store_record(table,s->default_values);        // Make empty default record
+  table->storeRecordAsDefault();        // Make empty default record
 
   if (session->variables.tmp_table_size == ~ (uint64_t) 0)		// No limit
     share->max_rows= ~(ha_rows) 0;
@@ -4890,7 +4890,7 @@
 bool Table::compare_record()
 {
   if (s->blob_fields + s->varchar_fields == 0)
-    return cmp_record(this, record[1]);
+    return memcmp(this->record[0], this->record[1], (size_t) s->reclength);
   /* Compare null bits */
   if (memcmp(null_flags,
 	     null_flags + s->rec_buff_length,
@@ -4906,9 +4906,64 @@
   return false;
 }
 
-
-
-
+/*
+ * Store a record from previous record into next
+ *
+ */
+void Table::storeRecord()
+{
+  //memcpy( a->record[1], a->record[0], (size_t) a->s->reclength )
+  memcpy( record[1], record[0], (size_t) s->reclength );
+}
+
+/*
+ * Store a record as an insert
+ *
+ */
+void Table::storeRecordAsInsert()
+{
+  memcpy( insert_values, record[0], (size_t) s->reclength );
+}
+
+/*
+ * Store a record with default values
+ *
+ */
+void Table::storeRecordAsDefault()
+{
+  memcpy( s->default_values, record[0], (size_t) s->reclength );
+}
+
+/*
+ * Restore a record from previous record into next
+ *
+ */
+void Table::restoreRecord()
+{
+  //memcpy( a->record[1], a->record[0], (size_t) a->s->reclength )
+  memcpy( record[0], record[1], (size_t) s->reclength );
+}
+
+/*
+ * Restore a record with default values
+ *
+ */
+void Table::restoreRecordAsDefault()
+{
+  memcpy( record[0], s->default_values, (size_t) s->reclength );
+}
+
+/*
+ * Empty a record
+ *
+ */
+void Table::emptyRecord()
+{
+  do {
+    restoreRecordAsDefault();
+    memset( null_flags, 255, s->null_bytes );
+  } while (0);
+}
 
 /*****************************************************************************
   The different ways to read a record

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-04-12 20:55:58 +0000
+++ drizzled/table.h	2009-04-25 00:00:44 +0000
@@ -106,7 +106,13 @@
   uint32_t find_shortest_key(const key_map *usable_keys);
   bool compare_record(Field **ptr);
   bool compare_record();
-
+  /* TODO: the (re)storeRecord's may be able to be further condensed */
+  void storeRecord();
+  void storeRecordAsInsert();
+  void storeRecordAsDefault();
+  void restoreRecord();
+  void restoreRecordAsDefault();
+  void emptyRecord();
   bool table_check_intact(const uint32_t table_f_count, const TABLE_FIELD_W_TYPE *table_def);
 
   /* See if this can be blown away */

=== modified file 'drizzled/unireg.h'
--- drizzled/unireg.h	2009-04-10 05:31:39 +0000
+++ drizzled/unireg.h	2009-04-25 00:00:44 +0000
@@ -105,15 +105,15 @@
 #define MYF_RW MYF(MY_WME+MY_NABP)		/* Vid my_read & my_write */
 
 	/* Extern defines */
-#define store_record(A,B) memcpy((A)->B,(A)->record[0],(size_t) (A)->s->reclength)
-#define restore_record(A,B) memcpy((A)->record[0],(A)->B,(size_t) (A)->s->reclength)
-#define cmp_record(A,B) memcmp((A)->record[0],(A)->B,(size_t) (A)->s->reclength)
-#define empty_record(A)                                 \
+/* #define store_record(A,B) memcpy((A)->B,(A)->record[0],(size_t) (A)->s->reclength) */
+/* #define restore_record(A,B) memcpy((A)->record[0],(A)->B,(size_t) (A)->s->reclength) */
+/* #define cmp_record(A,B) memcmp((A)->record[0],(A)->B,(size_t) (A)->s->reclength) */
+/*#define empty_record(A)                                 \
   do {                                                  \
     restore_record((A),s->default_values);              \
     memset((A)->null_flags, 255, (A)->s->null_bytes);   \
   } while (0)
-
+*/
 /**
   This flag is used in function get_all_tables() which fills
   I_S tables with data which are retrieved from frm files and storage engine

